<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24">
            <Form id="search-form" :label-width="70" v-show="searchOpen" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="委托商:">
                <Input v-model="formObj.client" @on-enter="_formSearch" placeholder="请输入委托编号" clearable></Input>
              </Form-item>
              <Form-item class="search-item" label="委托编号:">
                <Input v-model="formObj.entrustCode" @on-enter="_formSearch" placeholder="请输入委托单位" clearable></Input>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">
            <btn-list :msg="btn" :open="searchOpen" @on-result-change="_btnClick" :showSearchBtn="true"
                     class="contHide">
            </btn-list>
          </Col>
          <!-- 表格 -->
          <Col span="24">
            <PTVXETable
              ref="pageTable"
              :tableHeight="tableHeight"
              :getPage="getPage"
              :iconMsg="iconMsg"
              @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :width="item.width"
                :min-width="200"
                :fixed="item.fixed?item.fixed:undefined"
                sortable
              >
                <template slot-scope="scope">
                  <div v-if="item.detail"><a @click.stop="_detailModal(scope.row.id,scope.row.type)">{{scope.row[item.key]}}</a>
                  </div>
                  <span v-else-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}</span>
                  <span v-else-if="item.status">{{scope.row[item.key].display}}</span>
                  <div v-else-if="item.type">{{scope.row[item.key] === 0 ? '企业':scope.row[item.key] ===
                    1?'政府':scope.row[item.key] === 2?'食品类抽样单': ''}}
                  </div>
                  <div v-else>{{scope.row[item.key]}}</div>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <!--组件加载-->
    <!--选择领样人-->
    <UserInfo ref="userModal" @on-result-change="_userResult"></UserInfo>
    <Operation ref="operation"></Operation>
    <AuditDataModal ref="sampleManageModal" @on-result-change="_page"></AuditDataModal>
    <FileManage ref="FileManage"></FileManage>
  </div>
</template>
<script>
import UserInfo from '../../../components/user-info-single/assignPerson'
import { soilTest } from '../../../api'
import Operation from '../../../components/operation/Operation'
import AuditDataModal from './AuditDataModal'
export default {
  components: {
    UserInfo,
    Operation,
    // eslint-disable-next-line vue/no-unused-components
    AuditDataModal
  },
  data() {
    return {
      formObj: {
        client: undefined,
        entrustCode: undefined
      },
      typeList: [{ name: '企业', value: 0 }, { name: '政府', value: 1 }],
      iconMsg: [
        {
          type: 'ios-beaker',
          id: '',
          name: '审核数据'
        },
        { type: 'md-cloud', id: '', name: '附件' },
        {
          type: 'ios-clock',
          id: '',
          name: '操作日志'
        }
      ],
      getPage: {},
      pageColumns: [
        { title: '委托商', key: 'client', width: 200 },
        { title: '委托编号', key: 'entrustCode', width: 120 },
        { title: '委托日期', key: 'entrustDate', width: 120, date: true },
        { title: '钻孔位置', key: 'boreholeLocation', width: 120 },
        { title: '水深（米）', key: 'waterDepth', width: 120 },
        { title: '钻孔名称', key: 'boreholeName', width: 120 },
        { title: '进度', key: 'progress', width: 120, status: true },
        // { title: '工程号', key: 'projectNo', width: 120 },
        // { title: '报告编号', key: 'reportCode', width: 120 },
        { title: '制表日期', key: 'tabulateDate', width: 120, date: true },
        { title: '制表人', key: 'tabulater', width: 120 },
        // { title: '批准日期', key: 'approveDate', width: 120, date: true },
        // { title: '批准人', key: 'approver', width: 120 },
        { title: '检验类别', key: 'testType', width: 120 }
      ],
      searchOpen: false,
      btn: [
        {
          type: 'primary',
          id: 'ZBC',
          name: '一键接收'
        }
      ],
      selectIds: [],
      currentComponent: '',
      acceptSelectUserValue: ''
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('tabSearch')
      } else {
        return this.$tableHeight('tabNoSearch')
      }
    }
  },
  mounted() {
    this._page()
    // 样品接收是否选择人员
    // this.acceptSelectUserValue = localStorage.getItem('acceptSelectUserValue')
  },
  methods: {
    _userResult(data, msg) {
      const sendData = {
        ids: this.selectIds.join(',')
      }
      if (data) {
        sendData.person = data.realname
        sendData.personId = data.userId
      }
      switch (msg) {
        case 'contractSendMan':
          // 一键发放
          this.$store.dispatch('FoodContract/oneKeySend', sendData).then(() => {
            this._resultChange('发放成功')
          })
          break
        case 'contractReceiveSendMan':
          // 一键接收并发放
          this.$store
            .dispatch('FoodContract/oneKeyReceiveSend', sendData)
            .then(() => {
              this._resultChange('一键接收并发放成功')
            })
          break
        case 'sampleSendScanMan':
          // 扫码发放
          this.$refs.refModal._open('扫码发放', data)
          break
        case 'sampleReceiveSendScanMan':
          // 扫码接收并发放
          this.$refs.refModal._open('扫码接收发放', data)
          break
      }
    },
    // 一键接收并发放

    // 组件返回值
    _componentResult(data, msg) {
      switch (this.currentComponent) {
        default:
          this._page()
      }
    },
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(() => {
        switch (msg) {
          case 'search':
            this.searchOpen = !this.searchOpen
            break
          default:
            this._btnOption(msg)
        }
      })
    },
    // btn操作
    _btnOption(msg) {
      console.log(msg)
      switch (msg) {
        case '一键接收':
          this._oneKeyReceive()
          break
        case '一键发放':
          this._oneKeySend()
          break
        case '一键接收并发放':
          this._oneKeyReceiveSend()
          break
        case '扫码接收':
          this.currentComponent = 'ReceiveScan'
          this.$nextTick(function() {
            this.$refs.refModal._open()
          })
          break
        case '扫码发放':
          this._scanSend('sampleSendScanMan')
          break
        case '扫码接收并发放':
          this._scanSend('sampleReceiveSendScanMan')
          break
        case '信息维护':
          this._maintainInfo()
          break
        case '登记协议':
          this._editModals(msg)
          break
      }
    },
    // 扫码接收并发放
    _scanSend(msg) {
      if (msg === 'sampleReceiveSendScanMan' || msg === 'sampleSendScanMan') {
        // 扫码接收并发放判断是够选人
        if (this.acceptSelectUserValue === '是') {
          this.$refs.userModal._open(msg, '请选择领样人')
        } else {
          this.$refs.refModal._open('扫码发放')
        }
      } else {
        // 其他
        this.$refs.userModal._open(msg, '请选择领样人')
      }
    },
    // 一键接收并发放
    _oneKeyReceiveSend() {
      if (this.selectIds.length === 0) {
        this.$msgTip('warning', '请至少选择一条数据！')
      } else {
        // 根据字典是否选择人员
        // eslint-disable-next-line no-lonely-if
        if (this.acceptSelectUserValue === '是') {
          // 选择人员接收并发放
          this.$store
            .dispatch('FoodContract/oneKeyReceiveSendCheck', {
              ids: this.selectIds.join(',')
            })
            .then(() => {
              const result = this.$store.state.FoodContract.success
              if (result) {
                // 验证成功
                this.$refs.userModal._open(
                  'contractReceiveSendMan',
                  '请选择领样人'
                )
              }
            })
        } else {
          // 不选择人员
          this.$store
            .dispatch('FoodContract/oneKeyReceiveSend', {
              ids: this.selectIds.join(',')
            })
            .then(() => {
              this._resultChange('一键接收并发放成功')
            })
        }
      }
    },
    // 一键发放
    _oneKeySend() {
      if (this.selectIds.length === 0) {
        this.$msgTip('warning', '请至少选择一条数据！')
      } else {
        // 一键发放判断是否选人
        // eslint-disable-next-line no-lonely-if
        if (this.acceptSelectUserValue === '是') {
          this.$store
            .dispatch('FoodContract/oneKeySendCheck', {
              ids: this.selectIds.join(',')
            })
            .then(() => {
              if (this.$store.state.FoodContract.success) {
                this.$refs.userModal._open('contractSendMan', '请选择领样人')
              }
            })
        } else {
          // 一键发放
          this.$store
            .dispatch('FoodContract/oneKeySend', {
              ids: this.selectIds.join(',')
            })
            .then(() => {
              this._resultChange('发放成功')
            })
        }
      }
    },
    // 一键接收
    _oneKeyReceive() {
      if (this.selectIds.length === 0) {
        this.$msgTip('warning', '请至少选择一条数据！')
      } else {
        this.$Modal.confirm({
          title: '提示',
          content:
            '确定要一键接收这 ' + this.selectIds.length + ' 条委托下的样品？',
          onOk: () => {
            this.$store
              .dispatch('FoodContract/oneKeyReceive', {
                ids: this.selectIds.join(',')
              })
              .then(() => {
                this._resultChange('接收成功')
              })
          }
        })
      }
    },
    // 信息维护
    _maintainInfo() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.currentComponent = 'MaintainInfoModal'
        this.$nextTick(() => {
          this.$refs.refModal._open(this.selectIds, 1)
        })
      }
    },
    _iconClick(res, data, currentComponent) {
      this.currentComponent = currentComponent
      console.log(res)
      this.$nextTick(() => {
        switch (res) {
          case '审核数据':
            this._editModal(data.id, data.type, data.cname)
            break
          case '项目管理':
            this.$refs.itemManageModal._open(data.id)
            break
          case '编辑协议':
            this._editModals(res, data)
            break
          case '附件':
            this._upload(data.id)
            break
          case '操作日志':
            this._operationRecord(data.id)
            break
        }
      })
    },
    _editModal(id, type, name) {
      this.$refs.sampleManageModal._open(id, type, '数据录入')
    },
    _editModals(res, data) {
      if (res === '登记协议') {
        this.$refs.editModal._open(res, data)
      } else if (res === '编辑协议') {
        this.$store
          .dispatch('FoodContract/verificationEdit', { id: data.id })
          .then(() => {
            if (this.$store.state.FoodContract.model === true) {
              this.$refs.editModal._open(res, data)
            }
          })
      }
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this.getPage = this.$store.state.FoodContract.page
          break
        case 'selectIds':
          this.selectIds = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      console.log('this.formObj', this.formObj)
      const result = await soilTest.pageExpAudit(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _detailModal(id, type) {
      // 查看
      this.$store.dispatch('FoodContract/getById', id).then(() => {
        if (type === 0) {
          // 企业委托 ’0‘
          this.currentComponent = 'FoodContractCompanyDetail'
        } else {
          // 政府委托 ’1‘
          this.currentComponent = 'FoodContractGovernDetail'
        }
        this.$nextTick(() => {
          this.$refs.refModal._open(this.$store.state.FoodContract.model)
        })
      })
    },
    _search() {
      this._page()
    },
    _operationRecord(id) {
      // 操作日志
      this.$refs.operation._open(id)
    },
    _resultChange(msg) {
      if (this.$store.state.FoodContract.success) {
        this._page()
        this.$Message.success(msg)
        this.selectIds = []
      }
    },
    _upload(id) {
      // 上传文件
      this.$refs.FileManage._open(id, 'entrustId')
    }
  }
}
</script>
